#==================NOTE====================#
# This function was coded by BlueCommander #
# Please don't claim this as your own work #
#   LINK www.youtube.com/c/BlueCommander   #
#==========================================#
#--------------MISC COMMANDS---------------#
gamerule commandBlockOutput false
execute as @e[type=armor_stand,tag=CustomBlock] run data merge entity @s {Fire:100,Marker:1b}
#----------DURABILITY TICK CHECK-----------#
execute as @a store result score @s ThisTickDur run data get entity @s SelectedItem.tag.Damage
execute as @a store result score @s ThisTickSlot run data get entity @s SelectedItemSlot
execute as @a unless score @s LastTickDur = @s ThisTickDur if score @s LastTickSlot = @s ThisTickSlot run tag @s add UsedTool
tag @a[scores={InstantSlime=1..}] add UsedTool
tag @a[scores={InstantInfest=1..}] add UsedTool
tag @a[scores={InstantTNT=1..}] add UsedTool
#------------BLOCK BOOK USING--------------#
execute as @a[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{CustomModelData:99}}},scores={OpenBook=1..}] run function moreblocks:print/page1
scoreboard players set @a OpenBook 0
scoreboard players enable @a blockbook
execute as @a[scores={blockbook=1..}] run give @s minecraft:carrot_on_a_stick{CustomModelData:99,display:{Name:"{\"text\":\"Block Book\",\"color\":\"white\",\"italic\":\"false\"}"}}
scoreboard players set @a blockbook 0
#------------FORCELOADING 0,0--------------#
function moreblocks:check_loaded
execute unless score Global Loaded matches 1.. unless score Global LastTickLoaded matches 0 run tellraw @a ["",{"text":"Custom Blocks API> ","color":"blue"},{"text":"You MUST force load the chunk 0,0! Click ","color":"none"},{"text":"here","color":"green","clickEvent":{"action":"suggest_command","value":"/forceload add 0 0 0 0"}},{"text":" for the command you need to run.","color":"none"}]
execute unless score Global Loaded matches 0 unless score Global LastTickLoaded matches 1.. run tellraw @a ["",{"text":"Custom Blocks API> ","color":"blue"},{"text":"0,0 is forceloaded!","color":"none"}]
scoreboard players operation Global LastTickLoaded = Global Loaded
#-------------PLACING BLOCKS---------------#
execute unless entity @e[name="StringMatcher",type=armor_stand] run summon minecraft:armor_stand 0 1 0 {CustomName:"{\"text\":\"StringMatcher\"}",Tags:["Temp1","Temp2"],NoGravity:1b,ShowArms:1b}
execute as @a[scores={PlaceBlock=1..},nbt={SelectedItem:{id:"minecraft:player_head",tag:{CustomModelData:1}}}] at @s positioned ~ ~1.5 ~ run function moreblocks:block_find
execute as @e[tag=PlayerItem] at @a[scores={PlaceBlock=1..}] if score @s BlockPlayerID = @e[distance=0,limit=1] BlockPlayerID as @e[distance=0,limit=1] run tag @s add UnselBlockPlace
execute as @e[tag=PlayerItem] at @a[scores={PlaceBlock=1..}] if score @s BlockPlayerID = @e[distance=0,limit=1] BlockPlayerID as @e[distance=0,limit=1] at @s positioned ~ ~1.5 ~ run function moreblocks:block_find
scoreboard players set @a PlaceBlock 0
#-------------PISTON MOVING----------------#
##################function moreblocks:pistons/main

#-------------BLOCK SAVE INIT--------------#
#execute if entity @e[tag=BlockSave,scores={BlockSaveID=100..}] as @e[tag=BlockSaveInit] run tellraw @a ["",{"text":"Custom Blocks API> ","color":"blue"},{"text":" Unfortunately, you have reached the block limit of 100 blocks. The block limit may be increased in the future.","color":"white"}]
#execute if entity @e[tag=BlockSave,scores={BlockSaveID=100..}] as @e[tag=BlockSaveInit] run kill @s
#execute unless entity @e[tag=BlockSave,scores={BlockSaveID=100..}] run tag @e[tag=BlockSaveInit,limit=1] add CurrentBlockSave
#execute as @e[tag=CurrentBlockSave] store result score @s BlockVersion run data get entity @s HandItems[0].tag.Version
#execute as @e[tag=CurrentBlockSave] if score @s BlockVersion > Global BlockVersion run tellraw @a ["",{"text":"Custom Blocks API> ","color":"blue"},{"text":"Fail to initialised block ","color":"white"},{"selector":"@s","color":"green"},{"text":"\nReason: ","color":"red"},{"text":"There is a new version of the data pack avaliable.\nDownload it from the generator page to use the generator!","color":"white"}]
#execute as @e[tag=CurrentBlockSave] if score @s BlockVersion > Global BlockVersion run kill @s
#execute as @e[tag=CurrentBlockSave] at @s run tp @s 0 0 0
#execute as @e[tag=CurrentBlockSave] run tellraw @a ["",{"text":"Custom Blocks API> ","color":"blue"},{"text":"Successfully initialised block ","color":"white"},{"selector":"@s","color":"green"}]
#execute as @e[tag=CurrentBlockSave] run scoreboard players set @s BlockSaveGet 1
#execute as @e[tag=CurrentBlockSave] run tag @s remove BlockSaveInit
#-------------BLOCK SAVE IDS---------------#
#execute as @e[tag=CurrentBlockSave] unless score @s BlockSaveID matches 0.. run scoreboard players add Global BlockSaveID 1
#execute as @e[tag=CurrentBlockSave] unless score @s BlockSaveID matches 0.. run scoreboard players operation @s BlockSaveID = Global BlockSaveID
#execute as @e[tag=CurrentBlockSave] run tag @s remove CurrentBlockSave

execute if score Global BlockSaveID <= Global IDTranfPos run scoreboard players set Global IDTranfPos 0
scoreboard players add Global IDTranfPos 1
execute as @e[tag=BlockSave] if score Global IDTranfPos = @s BlockSaveID run tag @s add IDTranfSel
execute as @e[tag=IDTranfSel] store result score Global BlockIDTranf run scoreboard players get @s BlockSaveID
scoreboard players remove Global BlockIDTranf 1
execute unless entity @e[tag=IDTranfSel,scores={BlockSaveID=1}] run scoreboard players set Global DoIDTranf 1
execute if score Global BlockSaveID matches 0 run scoreboard players set Global DoIDTranf 0
execute as @e[tag=BlockSave] if score Global BlockIDTranf = @s BlockSaveID run scoreboard players set Global DoIDTranf 0
execute if score Global DoIDTranf matches 1.. as @e[tag=IDTranfSel,scores={BlockSaveID=2..}] run scoreboard players remove @s BlockSaveID 1
tag @e[tag=IDTranfSel] remove IDTranfSel

execute unless score Global Loaded matches 0 run scoreboard players set Global IDUpdated 0
execute unless score Global Loaded matches 0 as @e[scores={BlockSaveID=1..},type=armor_stand] if score Global BlockSaveID = @s BlockSaveID run scoreboard players set Global IDUpdated 1
execute unless score Global Loaded matches 0 if score Global IDUpdated matches 0 if score Global BlockSaveID matches 1.. as @a run function moreblocks:print/page1
execute unless score Global Loaded matches 0 if score Global IDUpdated matches 0 if score Global BlockSaveID matches 1.. as @a run tellraw @s ["",{"text":"A block was removed so all ID's have been rearranged.\n#---------------------------------------#","color":"white"}]
execute unless score Global Loaded matches 0 if score Global IDUpdated matches 0 if score Global BlockSaveID matches 1.. run scoreboard players remove Global BlockSaveID 1
#---------------PLAYER IDS-----------------#
execute as @a unless score @s BlockPlayerID matches 0.. run scoreboard players add Global BlockPlayerID 1
execute as @a unless score @s BlockPlayerID matches 0.. run scoreboard players operation @s BlockPlayerID = Global BlockPlayerID
#----------CURRENT ITEM STORAGE------------#
#execute unless entity @e[type=minecraft:armor_stand,tag=BlockSave,nbt={CustomName:"{\"text\":\"Brush(UP)\"}"}] run summon armor_stand ~ ~ ~ {NoGravity:1b,ShowArms:1b,Marker:1b,Invisible:1b,PersistenceRequired:1b,Tags:["BlockSave","BlockSaveInit"],HandItems:[{id:"minecraft:player_head",Count:1b,tag:{Version:1,StatMessage:"/tellraw @p [\"\",{\"text\":\"REAL BLOCK: \",\"color\":\"white\"},{\"text\":\"Wool\",\"color\":\"green\",\"hoverEvent\":{\"action\":\"show_text\",\"value\":{\"text\":\"\",\"extra\":[{\"text\":\"NBT: \"},{\"text\":\"None\",\"color\":\"green\"}]}}},{\"text\":\"\\nDROP: \",\"color\":\"none\"},{\"text\":\"Itself\",\"color\":\"green\",\"hoverEvent\":{\"action\":\"show_text\",\"value\":{\"text\":\"\",\"extra\":[{\"text\":\"AMOUNT: \"},{\"text\":\"1\",\"color\":\"green\"},{\"text\":\"\\nNBT: \"},{\"text\":\"None\",\"color\":\"green\"}]}}},{\"text\":\"\\nTOOL FOR DROP: \",\"color\":\"none\"},{\"text\":\"No Tool Required\",\"color\":\"green\"},{\"text\":\"\\nXP DROPPED: \",\"color\":\"none\"},{\"text\":\"0 points\",\"color\":\"green\"},{\"text\":\"\\n#---------------------------------------#\",\"color\":\"none\"}]",CustomModelData:1,SkullOwner:{Id:"4ec8a8e9-cd13-4b87-8e1c-6161db835bad",Properties:{textures:[{Value:"eyJ0ZXh0dXJlcyI6eyJTS0lOIjp7InVybCI6Imh0dHA6Ly90ZXh0dXJlcy5taW5lY3JhZnQubmV0L3RleHR1cmUvOGU4YjE1MDM2YWMyOTEyNGQwNDI5NDMxZDRmYjEzZmYzNjM1OTlkNzZmMTY3NGI5YTZlNGI3OGNiYzBjM2VkZCJ9fX0="}]}},RealBlock:"/setblock ~ ~ ~ minecraft:white_wool",RealBlockRaw:"minecraft:white_wool",BlockDrop:{id:"NULL",Count:1b},BlockVarTool:"always",BlockVarToolLevel:"anyrequired",BlockVarXpAmount:0,BlockVarDirectional:1,display:{Name:"{\"text\":\"Brush(UP)\",\"color\":\"white\",\"italic\":\"false\"}"}}},{}],CustomName:"{\"text\":\"Brush(UP)\"}"}
#------------PLAYER HEAD FIXES-------------#
#-----------PREPARING NEXT TICK------------#
tag @a remove UsedTool
scoreboard players set @a InstantSlime 0
scoreboard players set @a InstantInfest 0
scoreboard players set @a InstantTNT 0
execute as @a run scoreboard players operation @s LastTickDur = @s ThisTickDur
execute as @a run scoreboard players operation @s LastTickSlot = @s ThisTickSlot
#------------------------------------------#
